import { BaseItem } from '@algolia/autocomplete-core';
import { CreateTagsPluginParams } from './createTagsPlugin';
import { DefaultTagType, BaseTag, Tag } from './types';
export declare type OnTagsChangeParams<TTag extends DefaultTagType = DefaultTagType> = {
    prevTags: Array<Tag<TTag>>;
    tags: Array<Tag<TTag>>;
};
declare type OnTagsChangeListener<TTag extends DefaultTagType = DefaultTagType> = (params: OnTagsChangeParams<TTag>) => void;
declare type CreateTagsParams<TItem extends BaseItem, TTag extends DefaultTagType = DefaultTagType> = Pick<CreateTagsPluginParams<TItem, TTag>, 'initialTags'>;
export declare function createTags<TItem extends BaseItem, TTag extends DefaultTagType = DefaultTagType>({ initialTags }: CreateTagsParams<TItem, TTag>): {
    get(): Tag<TTag>[];
    set(baseTags: Array<BaseTag<TTag>>): void;
    add(baseTags: Array<BaseTag<TTag>>): void;
    onChange(listener: OnTagsChangeListener<TTag>): void;
};
export {};
